local driftmodmeter = nil;
local fourPlayerMeter = nil;

local nobluemeter = nil;
local noblue4p = nil;

local smallSlot = nil;
local smallSnkr = nil;
local smallHyuu = nil;
local smallRocket = nil;
local specialIcon = nil;
local smallSpecialIcon = nil;

local bigSlot = nil;
local bigHyuu = nil;
local bigRocket = nil;

local dfm_itemtimer = nil;
local timerForP1 = nil

local hyuutime = 7*TICRATE;
local itemtime = 8*TICRATE;

local dmod_visReady = false;
local dmodDebug = false;

if (dmodDebug) then print("NITRO DEBUG MODE ON. GAMEPLAY INTENDED FOR MECHANIC TESTING.") end

local dm_neoscoreboard = false

local FRACUNIT = FRACUNIT;

local customPrompt = {"Custom 1", "Custom 2", "Custom 3"};

local infoSt1 = "\x89".."DRIFTNITRO, version 1.0.1 by Azur and Froge\n".."\x80".."Fill your ".."\x87".."orange meter ".."\x80".."by drifting to get boost items!\n"

local infoSt2 = "Your ".."\x84".."blue meter ".."\x80".."will fill over time. \n Once full, hit ".."\x82".."Custom 3 (or your set custom button)\x80".." to use a ".."\x82".."special item!".."\x80".."\n(This message will only appear once.)"

freeslot("sfx_dmget", "MT_RANDOMITEMBOXSPAWNER", "MT_RANDOMITEMBOX");

local dmodsparkcolors = {
    SKINCOLOR_SAPPHIRE,
    SKINCOLOR_KETCHUP,
    "rainbow"
}

rawset(_G, "driftmodData",
{
	isOn = false;
	blueOn = true;
	doHyuuBoosting = true;
	limitRockets = true;
	meterRate = 114;
	blueRate = 114;
	bonusDiv = 4;
	specialMtrSize = 100000;
	itemboxTypes = {423, 524}; // array for number of item boxes to get rid of, moved here out of fear of desyncs
	maxiboxtypes = 2;
	hyuuFactor = 25;
	rktLimitTime = ((7*TICRATE)/2);
})

local barColors = {89, 229}

local extraPoints = {200, 400, 600}

addHook("NetVars", function(n)
	driftmodData = n($) // let's see how a netvar fares
end)

local cv_driftmod = CV_RegisterVar({
	name = "driftnitro",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local function getFloatString(n)
	local floatPrint = "nil";
	if (n % 100 == 0)
		floatPrint = tostring(n)
	else
		floatPrint = tostring(n/100).."."..(n % 100);
	end
	
	return floatPrint;
end

local function getKartSpeedByValue(spd) // won't contain nuances like player scale but I don't believe that's the goal here
	local k_speed = 150;
	local g_cc = FRACUNIT;
	local xspd = 3072;		-- 4.6875 aka 3/64
	local kartspeed = spd;
	local finalspeed;

	//switch (gamespeed) -- WOW, LUA HAS NO SWITCH STATEMENTS
	if (gamespeed == 0)
		g_cc = 53248 + xspd; //  50cc =  81.25 + 4.69 =  85.94%
	elseif (gamespeed == 2)
		g_cc = 77824 + xspd; // 150cc = 118.75 + 4.69 = 123.44%
	elseif (gamespeed == 1)
		g_cc = 65536 + xspd; // 100cc = 100.00 + 4.69 = 104.69%
	end

	if (G_BattleGametype())
		kartspeed = 1;
	end

	k_speed = ($ + kartspeed*3); // 153 - 177

	local pScale = ((mapobjectscale) and mapobjectscale or FRACUNIT)
	finalspeed = FixedMul(FixedMul(k_speed<<14, g_cc), pScale)

	return finalspeed;
end

local function dumpInfo(p)
	local floatedOrange = getFloatString(driftmodData.meterRate);
	local floatedBlue = getFloatString(driftmodData.blueRate);
	local meterSize = (((driftmodData.specialMtrSize)/1000).." * 10 = "..((driftmodData.specialMtrSize)/100));
	
	local heehee = (100/driftmodData.bonusDiv);
	local bonusfactor = getFloatString(heehee);
	heehee = nil;
	
	local legost = getFloatString(driftmodData.hyuuFactor);
	local antismug = (driftmodData.rktLimitTime/TICRATE)-1;
	
	local fallbackSpd = getKartSpeedByValue(5);
	local realspeed = ((p.realKSpeed) and p.realKSpeed or fallbackSpd);
	fallbackSpd = nil; // nilling it because desync paranoia
	
	local readablespeed = ((mapobjectscale) and (realspeed/mapobjectscale) or (realspeed/FRACUNIT)); //brain forgets this is literally 0 outside of maps
	realspeed = nil; //nilling this too
	
	
	CONS_Printf(p, "\x87".."Orange meter rate: ".."\x80"..floatedOrange.."% ".."\x82".." (Default rate: 1.14%)");
	
	if (driftmodData.blueOn)
		CONS_Printf(p, "\x84".."Blue meter: ".."\x83".."ON".."\x80");
		CONS_Printf(p, "\x84".."Blue meter rate: ".."\x80"..floatedBlue.."% ".."\x82".." (Default rate: 1.14%)");
		CONS_Printf(p, "\x84".."Blue meter length: ".."\x80"..meterSize);
	else
		CONS_Printf(p, "\x84".."Blue meter: ".."\x85".."OFF".."\x80");
	end
	CONS_Printf(p, "Hyudoro boost factor: "..legost.."\x82".." \n(metric: Absolute value of: ("..readablespeed.." - ("..readablespeed.." x 1.243)) x "..legost.." )\n(Note: "..readablespeed.." is your REAL kartspeed!)\n");
	if (driftmodData.limitRockets)
		CONS_Printf(p, "\x83".."The rocket sneaker duration is being position-limited.".."\x80");
		CONS_Printf(p, "Limited time: Approx. "..antismug.." seconds".."\x82".." (default approx. 3 sec.). \nNOTE: This time is only set when you enter first place.\n");
	else
		CONS_Printf(p, "\x85".."The rocket sneaker duration is NOT being position-limited.".."\x80");
	end
	CONS_Printf(p, "Bonus factor: "..bonusfactor);
	CONS_Printf(p, "\x82".."Orange bonus metric: ".."\x87".."Orange rate ".."\x82".."x Position x Distance".."\x80");
	if (driftmodData.blueOn) then CONS_Printf(p, "\x82".."Blue bonus metric: ".."\x84".."Blue rate ".."\x82".."x (Position x 13)".."\x80"); end
end

COM_AddCommand("dfm_setcustomtype", function(player, num)
	local n = (tonumber(num))
	if (not (gamestate == GS_LEVEL or gamestate == GS_INTERMISSION or gamestate == GS_VOTING))
		CONS_Printf(player, "You must be in a level to use this.\n");
		return
	end
	if (((num == nil) or (n <= 0)) or (n > 3))
			CONS_Printf(player, "Please specify a value between 1 and 3. \n".."\x82".."There are only 3 custom buttons. The number you put in will set your special item button to the corresponding custom button.".."\x80".."\n")
	else
			if (n == 1)
				player.specialBtMem = BT_CUSTOM1;
				player.cusPref = 1;
			elseif (n == 2)
				player.specialBtMem = BT_CUSTOM2;
				player.cusPref = 2;
			elseif (n == 3)
				player.specialBtMem = BT_CUSTOM3;
				player.cusPref = 3;
			end
			if (gamestate == GS_INTERMISSION or gamestate == GS_VOTING)
				CONS_Printf(player, "Your special item button will be Custom "..num.." next round.")
			elseif (gamestate == GS_LEVEL)
				CONS_Printf(player, "Your special item button will be Custom "..num.." next round.")
			end
	end
 end, 0)
 
COM_AddCommand("dfm_rocketlimit", function(player, onoff)
	if (IsPlayerAdmin(player) or player == server) then
		local toggleChoice = 0;
		local offTypes = {"Off", "off", "No", "no", "False", "false", "0"} // sets toggleChoice to 1
		local onTypes = {"On", "on", "Yes", "yes", "True", "true", "1"} // sets toggleChoice to 2
		
		for i = 1, #offTypes
			if onoff == offTypes[i] then toggleChoice = 1 end
		end
		
		for i = 1, #onTypes
			if onoff == onTypes[i] then toggleChoice = 2 end
		end
		
		if ((toggleChoice == 1) and (driftmodData.limitRockets ~= false))
			CONS_Printf(player, "\nThe rocket sneaker limit is now off.")
			driftmodData.limitRockets = false
		elseif ((toggleChoice == 2) and (driftmodData.limitRockets ~= true))
			CONS_Printf(player, "\nThe rocket sneaker limit is now on.")
			driftmodData.limitRockets = true
		else
			local isOnOff = ((driftmodData.limitRockets) and "on." or "off.")
			CONS_Printf(player, "\nThe rocket sneaker limit is currently "..isOnOff)
		end
	else
		CONS_Printf(player, "\nYou must be an admin to use this command.")
	end
 end, 0)

COM_AddCommand("dfm_bluemeter", function(player, onoff)
	if (IsPlayerAdmin(player) or player == server) then
		local toggleChoice = 0;
		local offTypes = {"Off", "off", "No", "no", "False", "false", "0"} // sets toggleChoice to 1
		local onTypes = {"On", "on", "Yes", "yes", "True", "true", "1"} // sets toggleChoice to 2
		
		for i = 1, #offTypes
			if onoff == offTypes[i] then toggleChoice = 1 end
		end
		
		for i = 1, #onTypes
			if onoff == onTypes[i] then toggleChoice = 2 end
		end
		
		if ((toggleChoice == 1) and (driftmodData.blueOn ~= false))
			CONS_Printf(player, "\nThe blue meter is now off.")
			driftmodData.blueOn = false
		elseif ((toggleChoice == 2) and (driftmodData.blueOn ~= true))
			CONS_Printf(player, "\nThe blue meter is now on.")
			driftmodData.blueOn = true
		else
			local isOnOff = ((driftmodData.blueOn) and "on." or "off.")
			CONS_Printf(player, "\nThe blue meter is currently "..isOnOff)
		end
	else
		CONS_Printf(player, "\nYou must be an admin to use this command.")
	end
 end, 0)

COM_AddCommand("dfm_setbluelength", function(player, num)
	local fracced = floatToFrac(num)
	if (IsPlayerAdmin(player) or player == server) then
		if ((num == nil) or (fracced <= 0))
			CONS_Printf(player, "Please specify a value greater than 0.")
		elseif ((fracced > 20000))
			CONS_Printf(player, "Please specify a value less than or equal to 200.")
		else
			CONS_Printf(player, "The blue meter length is now "..num.."%.\n".."\x82".."NOTE: The final length is the value you put in times 10.")
			CONS_Printf(player, "\x82".."Default value: 100")
			driftmodData.specialMtrSize = (fracced*10)
		end
	else
		CONS_Printf(player, "\nYou must be an admin to use this command.")
	end
 end, 0)
 
COM_AddCommand("dfm_getinfo", function(player)
	dumpInfo(player);
 end, 0)
 
COM_AddCommand("dfm_setbluerate", function(player, num)
	if (IsPlayerAdmin(player) or player == server) then
		local n = (tonumber(num))
		local fracced = floatToFrac(num)
		if ((num == nil) or (fracced <= 0))
			CONS_Printf(player, "Please specify a value greater than 0.")
		elseif ((fracced > 9999))
			CONS_Printf(player, "Please specify a value less than or equal to 99.99.")
		else
			CONS_Printf(player, "The ".."\x84".."blue meter rate ".."\x80".."is now "..num.."%.\n".."\x82".."NOTE: The default value is 1.14%.")
			driftmodData.blueRate = fracced
		end
	else
		CONS_Printf(player, "\nYou must be an admin to use this command.")
	end
 end, 0)

COM_AddCommand("dfm_setmeterrate", function(player, num)
	if (IsPlayerAdmin(player) or player == server) then
		local n = (tonumber(num))
		local fracced = floatToFrac(num)
		//print(fracced)
		if ((num == nil) or (fracced <= 0))
			CONS_Printf(player, "Please specify a value greater than 0.")
		elseif ((fracced > 9999))
			CONS_Printf(player, "Please specify a value less than or equal to 99.99.")
		else
			CONS_Printf(player, "The ".."\x87".."orange meter rate ".."\x80".."is now "..num.."%.\n".."\x82".."NOTE: The default value is 1.14%.")
			driftmodData.meterRate = fracced
		end
	else
		CONS_Printf(player, "\nYou must be an admin to use this command.")
	end
 end, 0)
 
COM_AddCommand("dfm_setbonusdiv", function(player, num)
	if (IsPlayerAdmin(player) or player == server) then
		local n = (tonumber(num))
		if ((num == nil) or (n <= 0))
			CONS_Printf(player, "Please specify a value greater than or equal to 2.")
		elseif ((n > 10))
			CONS_Printf(player, "Please specify a value less than or equal to 10.")
		else
			CONS_Printf(player, "The bonus division is now "..num.."\x82".."NOTE: The default value is 4.")
			driftmodData.bonusDiv = n
		end
	else
		CONS_Printf(player, "\nYou must be an admin to use this command.")
	end
 end, 0)  
 
COM_AddCommand("dfm_sethyuufactor", function(player, num)
	if (IsPlayerAdmin(player) or player == server) then
		local n = (tonumber(num))
		local fracced = floatToFrac(num)
		if ((num == nil) or (fracced <= 0))
			CONS_Printf(player, "Please specify a value greater than 0.")
		elseif ((fracced > 200))
			CONS_Printf(player, "Please specify a (decimal) value less than or equal to 2.")
		else
			CONS_Printf(player, "The Hyudoro boost factor is now "..num..".\n".."\x82".."NOTE: The default value is 0.25%.")
			driftmodData.hyuuFactor = fracced
		end
	else
		CONS_Printf(player, "\nYou must be an admin to use this command.")
	end
 end, 0)
 
COM_AddCommand("dfm_setrocketlimit", function(player, num)
	if (IsPlayerAdmin(player) or player == server) then
		local n = (tonumber(num))
		local fracced = floatToFrac(num)
		
		if (not driftmodData.limitRockets)
			CONS_Printf(player, "Rocket Sneakers are not being limited.")
		elseif ((num == nil) or (fracced < 50))
			CONS_Printf(player, "Please specify a (decimal) value greater than or equal to 0.5.")
		elseif ((fracced > 2000))
			CONS_Printf(player, "Please specify a (decimal) value less than or equal to 20.")
		else
			CONS_Printf(player, "The limited Rocket Sneaker time is now "..num.." seconds.\n".."\x82".."NOTE: The default time is 2.5 seconds.")
			driftmodData.rktLimitTime = ((fracced*TICRATE)/100)+TICRATE
		end
	else
		CONS_Printf(player, "\nYou must be an admin to use this command.")
	end
 end, 0)
 
 
// ALWAYS cache the patches, stop desyncing FUCK
hud.add(function(v, p)
	if (dmod_visReady ~= true)
		// cache patches for item slots and sneakers
		smallSlot = v.cachePatch("K_ISBG");
		bigSlot = v.cachePatch("K_ITBG");
		smallSnkr = v.cachePatch("K_ISSHOE");
		smallHyuu = v.cachePatch("K_ISHYUD");
		smallRocket = v.cachePatch("K_ISRSHE");
		bigHyuu = v.cachePatch("K_ITHYUD");
		bigRocket = v.cachePatch("K_ITRSHE");
		
		specialIcon = {smallHyuu, smallRocket, bigHyuu, bigRocket};
		smallSpecialIcon = {v.cachePatch("DTHYUD"), v.cachePatch("DTRSHE")}
		
		// get the 4P meter
		fourPlayerMeter = {v.cachePatch("DMTR4P1"), v.cachePatch("DMTR4P2"), v.cachePatch("DMTR4P3"), v.cachePatch("DMTR4P4")};
		noblue4p = {v.cachePatch("DMNB4P1"), v.cachePatch("DMNB4P2"), v.cachePatch("DMNB4P3"), v.cachePatch("DMNB4P4")};
		
		nobluemeter = {v.cachePatch("DRNBLSD"), v.cachePatch("DRSPSTD"), v.cachePatch("DRNBLWD")};
		
		// get the main meter
		if (driftmodmeter == nil)
			driftmodmeter = {v.cachePatch("DRMTRSD"), v.cachePatch("DRSPSTD"), v.cachePatch("DRMTRWD")};
		end
		
		// get the meter for hyuu and rocket
		dfm_itemtimer = {v.cachePatch("K_ITIMER"), v.cachePatch("K_ISIMER")}
		
		timerForP1 = v.cachePatch("DTMR1P")
		dmod_visReady = true
	end
end)

local function getDriftLevel(p)
    local pks = p.kartstuff
    local pdv = K_GetKartDriftSparkValue(p);
    local result = 0;

    if (pks[k_driftcharge] >= pdv*4)
		result = 3;
	elseif (pks[k_driftcharge] >= pdv*2)
        result = 2;
	elseif (pks[k_driftcharge] >= pdv)
		result = 1;
    end
    return result;
end

local function flipFromObject(mo, master)
	mo.eflags = (mo.eflags & ~MFE_VERTICALFLIP)|(master.eflags & MFE_VERTICALFLIP);
	mo.flags2 = (mo.flags2 & ~MF2_OBJECTFLIP)|(master.flags2 & MF2_OBJECTFLIP);

	if (mo.eflags & MFE_VERTICALFLIP)
		mo.z = $1 + master.height - FixedMul(master.scale, mo.height)
	end
end

local function matchGenericExtraFlags(mo, master)
	// flipping
	// handle z shifting from there too. This is here since there's no reason not to flip us if needed when we do this anyway;
	flipFromObject(mo, master);

	// visibility (usually for hyudoro)
	mo.flags2 = (mo.flags2 & ~MF2_DONTDRAW)|(master.flags2 & MF2_DONTDRAW);
	mo.eflags = (mo.eflags & ~MFE_DRAWONLYFORP1)|(master.eflags & MFE_DRAWONLYFORP1);
	mo.eflags = (mo.eflags & ~MFE_DRAWONLYFORP2)|(master.eflags & MFE_DRAWONLYFORP2);
	mo.eflags = (mo.eflags & ~MFE_DRAWONLYFORP3)|(master.eflags & MFE_DRAWONLYFORP3);
	mo.eflags = (mo.eflags & ~MFE_DRAWONLYFORP4)|(master.eflags & MFE_DRAWONLYFORP4);
end

local function getPlayercount()
	local g = 0;
	for p in players.iterate
		if p.mo and p.mo.valid
			g = $1 + 1;
		end
	end
	return g;
end

local function dmod_getRocketTime(p)
	local itemtime = 8*TICRATE;
	local pPos = p.kartstuff[k_position];
	local pCount = getPlayercount();
	
	// get top ranks
	local topRanks = ((pCount > 14) and (pCount/5) or 3);
	topRanks = ((pCount > 5) and $ or 1); // only 1st for anything less than 6P
	
	if K_IsPlayerLosing(p)
		return (itemtime*6);
	elseif (pCount == 1) // lonely bastard
		return (itemtime*6);
	elseif (pCount <= 20) // haha funny 32 player
		local estTop = (pCount/2);
		local div = (estTop-pPos);
		if (div <= 0) then div = 1; end // zero-divide prevention
		local finalTime = ((pPos > topRanks) and ((itemtime/div)*3) or (((itemtime/div)*3)/2)) // halve it for the top ranks, idiot
		return finalTime;
	else
		local estTop = (pCount/4); // treat it as if we don't have double the players
		local div = (estTop-(pPos/2));
		if (div <= 0) then div = 1; end
		local finalTime = ((pPos > topRanks) and ((itemtime/div)*3) or (((itemtime/div)*3)/2)) // halve it for the top ranks, idiot
		return finalTime;
	end
end

local function dmod_doRocketSneakerReward(p)
    if  p.kartstuff[k_rocketsneakertimer] > 0 then return end
    if not (p.mo and p.mo.valid) then return end

    local mo = nil;
    local prev = p.mo;
    local rkTime = dmod_getRocketTime(p);

    K_PlayBoostTaunt(p.mo);

    S_StartSound(p.mo, sfx_s3k3a);

    p.kartstuff[k_rocketsneakertimer] = rkTime;
    p.specialitemtype = 0;

    local moloop=0 while moloop<2 // for (moloop = 0; moloop < 2; moloop++)
        mo = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_ROCKETSNEAKER);
        matchGenericExtraFlags(mo, p.mo);
        mo.flags = ($ | MF_NOCLIPTHING);
        mo.angle = p.mo.angle;
        mo.threshold = 10;
        mo.movecount = moloop % 2;
		mo.lastlook = moloop+1;
        mo.movedir = mo.lastlook; // fuck off BLUA
        mo.target = p.mo;
        mo.hprev = prev;
        prev.hnext = mo;
        prev = mo;

        moloop=$+1
    end
end

local function dmod_rocketLimiter(p) // increase your rocket timer deterioration if you're winning
	local limittime = driftmodData.rktLimitTime;
	local pPos = p.kartstuff[k_position];
	local pCount = getPlayercount();
	
	if (pCount == 1) then return end; // only one player
	
	
	if (K_IsPlayerLosing(p) and (p.kartstuff[k_rocketsneakertimer])) // YOU NEED TO FUCKING HAVE ROCKETS
		p.doRocketReset = true
	end
	
	if (not p.doRocketReset) then return end; // you're not ready for resets yet
	
	local rocketAlreadySet = false
	
	if (p.kartstuff[k_rocketsneakertimer] <= (limittime)) then rocketAlreadySet = true; end // since the timer likes to reset itself
	
	if ((not K_IsPlayerLosing(p)) and (p.doRocketReset) and (pPos <= 1) and (not rocketAlreadySet)) // you are in first now, no more rockets
		 p.kartstuff[k_rocketsneakertimer] = (limittime);
		p.doRocketReset = false
	end
	
	
	pPos = nil
	pCount = nil
	// not nilling limittime because of paranoia
end

local function dmod_PlayerInWinningSection(p)
	local result = false;
	local pPos = p.kartstuff[k_position];
	local pCount = getPlayercount();
	local div25 = ((pCount*2)/5)
	local thirds = (pCount/3)
	
	if (pCount == 1) then return true; end // alone, just give him a hyuu
	
	if (pCount < 4)
		if (pPos <= 1) then result = true; end
	elseif (pCount < 6)
		if (pPos <= 2) then result = true; end
	elseif (pCount < 15) // division by 2.5 for a non-15+ playercount
		if (pPos <= div25) then result = true; end	
	else 
		if (pPos <= thirds) then result = true; end
	end
	
	pCount = nil
	div25 = nil
	thirds = nil
	
	return result;
end

local function K_calcSplitFlags(p, snapflags)
	local splitflags = 0;

	if (splitscreen == 0)
		return snapflags;
	end

	if (p != displayplayers[0])
		if (splitscreen == 1 and p == displayplayers[1])
			splitflags = ($ | V_SPLITSCREEN);
		elseif (splitscreen > 1)
			if (p == displayplayers[2] or (splitscreen == 3 and p == displayplayers[3]))
				splitflags = ($ | V_SPLITSCREEN);
			end
			if (p == displayplayers[1] or (splitscreen == 3 and p == displayplayers[3]))
				splitflags = ($ | V_HORZSCREEN);
			end
		end
	end

	if (splitflags & V_SPLITSCREEN)
		snapflags = ($ & ~V_SNAPTOTOP);
	else
		snapflags = ($ & ~V_SNAPTOBOTTOM);
	end

	if (splitscreen > 1)
		if (splitflags & V_HORZSCREEN)
			snapflags = ($ & ~V_SNAPTOLEFT);
		else
			snapflags = ($ & ~V_SNAPTORIGHT);
		end
	end

	return (splitflags|snapflags);
end

local function dmod_drawSlots(v, p) // fucking rocketsneakers
	local itAmt = p.kartstuff[k_itemamount]
	if (itAmt < 1) then return end // you have no sneakers, get outta here
	if (not splitscreen) then return end // gotta be in splitscreen
	// screen width/height metrics
	local scrwidth = v.width()/v.dupx();
    local winheight = v.height()/v.dupy();
    local windiff = ((winheight-200)/2)
    local left = (scrwidth - 320)/2;
	
	local scrxdiff = (scrwidth-320);
	local scrydiff = (winheight-200);
	
	local basewidth = (scrwidth-scrxdiff);
	
	local baseheight = (winheight-windiff);
	local widemetric = ((scrwidth >= 400) and 6 or 0);
	
	// gold colormap
	local goldColor = v.getColormap(TC_RAINBOW, SKINCOLOR_GOLD);
	local rbwColor = (1 + (leveltime % (MAXSKINCOLORS-1)));
	local colormode = TC_DEFAULT;
	local localcolor = SKINCOLOR_WHITE;
	
	// what patch to draw
	local patchType = bigSlot
	local specialType = p.specialitemtype
	local splitRebound = ((splitscreen > 1) and 2 or 0)
	
	if specialType == nil then specialType = 0 end
	
	// final coords for hud and flags...
	local fx = 0 
	local fy = 0
	local tx = 49
	local ty = 40
	local fflags = 0;	
	
	local itX = 5;
	local itY = 3;
	local itX2 = 5;
	local itY2 = 3;
	
	local offset = ((splitscreen > 1) and 1 or 0);
	local itembar = 0;
	local maxl = 1; // itembar's normal highest value
	local barlength = ((splitscreen > 1) and 12 or 26);
	
	local scrcenterx = ((scrwidth-scrxdiff)/2);
	
	if (p.kartstuff[k_itemblink] and ((leveltime %2) == 1))
			colormode = TC_BLINK;
			localcolor = SKINCOLOR_WHITE;
	end
	
	local cmap = v.getColormap(TC_RAINBOW, SKINCOLOR_SAPPHIRE);
	
	cmap = v.getColormap(colormode, localcolor);

	if (splitscreen)	// Splitscreen
		if (splitscreen > 1)	// 3P/4P Small Splitscreen
			// 1P (top left)
			itX = -9;
			itY = -8;

			// 2P (top right)
			itX2 = basewidth-39;
			itY2 = -8;
		end
	end
	
	if (splitscreen < 2) // don't change shit for THIS splitscreen.
		fx = itX;
		fy = itY;
		fflags = K_calcSplitFlags(p, V_SNAPTOTOP|V_SNAPTOLEFT);
	else // now we're having a fun game.
		patchType = smallSlot
		
		ty = 24
		if (p == displayplayers[0] or p == displayplayers[2]) // If we are P1 or P3...
			tx = 36
			fx = itX;
			fy = itY;
			fflags = V_SNAPTOLEFT|((p == displayplayers[2]) and V_SPLITSCREEN or V_SNAPTOTOP); // flip P3 to the bottom.
			// ^ very recently learned that BLUA conditionals DO exist, but in this weird way
		else // else, that means we're P2 or P4.
			tx = 1
			fx = itX2;
			fy = itY2;
			fflags = V_SNAPTORIGHT|((p == displayplayers[3]) and V_SPLITSCREEN or V_SNAPTOTOP); // flip P4 to the bottom
		end
	end
	
	// note to self: unless the patch is being recolored, DON'T GET A COLORMAP FOR IT
	v.draw(fx, fy, patchType, fflags);
	
	local numberdisplaymin = 2
	
	local sneakerpatch = ((offset) and smallSnkr or v.cachePatch("K_ITSHOE"));
	
	// Then, the numbers:
	if ((p.kartstuff[k_itemamount] >= numberdisplaymin) and (not p.kartstuff[k_itemroulette]))
		local itemmulsticker = ((offset) and v.cachePatch("K_ISMUL") or v.cachePatch("K_ITMUL"));
		v.draw(fx + (flipamount and 48 or 0), fy, itemmulsticker, fflags|(flipamount and V_FLIP or 0)); // flip this graphic for p2 and p4 in split and shift it.
		itemmulsticker = nil;
		v.draw(fx, fy, sneakerpatch, fflags);
		
		if (p.kartstuff[k_itemblink])
			v.draw(fx, fy, sneakerpatch, fflags, cmap);
		end
		
		if (offset)
			if (flipamount) // reminder that this is for 3/4p's right end of the screen.
				v.drawString(fx+2, fy+31, ("x"..(p.kartstuff[k_itemamount])), V_ALLOWLOWERCASE|fflags); 
			else
				v.drawString(fx+24, fy+31, ("x"..(p.kartstuff[k_itemamount])), V_ALLOWLOWERCASE|fflags); 
			end
		else
			v.draw(fy+28, fy+41, v.cachePatch("K_ITX"), fflags);
			v.drawKartString(fx+38, fy+36, p.kartstuff[k_itemamount], V_HUDTRANS|fflags);
		end
	else
		v.draw(fx, fy, sneakerpatch, fflags);
		
		if (p.kartstuff[k_itemblink])
			v.draw(fx, fy, sneakerpatch, fflags, cmap);
		end
	end
	
	sneakerpatch = nil
end

local function dmod_drawGoldSlots(v, p)
	local timerActive = p.kartstuff[k_rocketsneakertimer]+p.kartstuff[k_hyudorotimer]
	if ((not p.specialitemtype) and (not timerActive)) then return end // you have no special item, you're not using one either. we're done here
	if (not splitscreen) then return end // gotta be in splitscreen
	// screen width/height metrics
	local scrwidth = v.width()/v.dupx();
    local winheight = v.height()/v.dupy();
    local windiff = ((winheight-200)/2)
    local left = (scrwidth - 320)/2;
	
	local scrxdiff = (scrwidth-320);
	local scrydiff = (winheight-200);
	
	local basewidth = (scrwidth-scrxdiff);
	
	local baseheight = (winheight-windiff);
	local widemetric = ((scrwidth >= 400) and 6 or 0);
	
	// gold colormap
	local goldColor = v.getColormap(TC_RAINBOW, SKINCOLOR_GOLD);
	local rbwColor = (1 + (leveltime % (MAXSKINCOLORS-1)));
	local colormode = TC_DEFAULT;
	local localcolor = SKINCOLOR_WHITE;
	
	// what patch to draw
	local patchType = bigSlot
	local specialType = p.specialitemtype
	local splitRebound = ((splitscreen > 1) and 2 or 0)
	
	if specialType == nil then specialType = 0 end
	
	// final coords for hud and flags...
	local fx = 0 
	local fy = 0
	local tx = 49
	local ty = 40
	local fflags = 0;	
	
	local itX = 49;
	local itY = 3;
	local itX2 = 49;
	local itY2 = 3;
	
	local offset = ((splitscreen > 1) and 1 or 0);
	local itembar = 0;
	local maxl = 1; // itembar's normal highest value
	local barlength = ((splitscreen > 1) and 12 or 26);
	
	local scrcenterx = ((scrwidth-scrxdiff)/2);
	
	if (p.specialBlink and ((leveltime %2) == 1))
			colormode = TC_BLINK;
			localcolor = rbwColor;
	end
	
	local cmap = v.getColormap(TC_RAINBOW, SKINCOLOR_SAPPHIRE);
	
	cmap = v.getColormap(colormode, localcolor);

	if (splitscreen)	// Splitscreen
		if (splitscreen > 1)	// 3P/4P Small Splitscreen
			// 1P (top left)
			itX = 15;
			itY = -8;

			// 2P (top right)
			itX2 = basewidth-62;
			itY2 = -8;
		end
	end
	
	if (splitscreen < 2) // don't change shit for THIS splitscreen.
		fx = itX;
		fy = itY;
		fflags = K_calcSplitFlags(p, V_SNAPTOTOP|V_SNAPTOLEFT);
	else // now we're having a fun game.
		patchType = smallSlot
		
		ty = 24
		if (p == displayplayers[0] or p == displayplayers[2]) // If we are P1 or P3...
			tx = 36
			fx = itX;
			fy = itY;
			fflags = V_SNAPTOLEFT|((p == displayplayers[2]) and V_SPLITSCREEN or V_SNAPTOTOP); // flip P3 to the bottom.
			// ^ very recently learned that BLUA conditionals DO exist, but in this weird way
		else // else, that means we're P2 or P4.
			tx = 1
			fx = itX2;
			fy = itY2;
			fflags = V_SNAPTORIGHT|((p == displayplayers[3]) and V_SPLITSCREEN or V_SNAPTOTOP); // flip P4 to the bottom
		end
	end
	
	if ((specialType == 1) or (p.kartstuff[k_hyudorotimer]))
		local hyuumulti = ((kmp_hyudoro and kmp_hyudoro.value) and 6 or 3)
		maxl = ((hyuutime*hyuumulti)/2) - barlength;
	elseif ((specialType == 2) or (p.kartstuff[k_rocketsneakertimer]))
		maxl = (itemtime*6) - barlength;
	end
	
	v.draw(fx, fy, patchType, fflags, goldColor);
	if (specialType > 0)
		v.draw(fx, fy, specialIcon[specialType+(2-splitRebound)], fflags);
		
		
		if (p.specialBlink)
			v.draw(fx, fy, specialIcon[specialType+(2-splitRebound)], fflags, cmap);
		end
		
		if (splitscreen < 2)
			local hitNum = ((p.cusDisplay) and p.cusDisplay or 3)
			local hitMeText = "\x82"..customPrompt[hitNum].."\x80"
			v.drawString(fx+5, fy+47, hitMeText, V_ALLOWLOWERCASE|fflags, "thin")
			hitMeText = nil
			hitNum = nil
		else
			local xoff = -33
			if (p == displayplayers[0] or p == displayplayers[2]) 
				xoff = -32
			else
				xoff = 4
			end
			
			local hitNum = ((p.cusDisplay) and p.cusDisplay or 3)
			local hitMeText = "\x82"..customPrompt[hitNum].."\x80"
			v.drawString(fx+tx+xoff, fy+ty+12, hitMeText, V_ALLOWLOWERCASE|fflags, "thin")
			hitMeText = nil
			hitNum = nil
		end
	end
	
	if (p.kartstuff[k_hyudorotimer] and ((leveltime %2) == 1))
		v.draw(fx, fy, specialIcon[1+(2-splitRebound)], fflags);
	end
	
	if (p.kartstuff[k_rocketsneakertimer] and ((leveltime %2) == 1))
		v.draw(fx, fy, specialIcon[2+(2-splitRebound)], fflags);
	end
	
	// Extensible meter, currently only used for rocket sneaker...
	local itembar = timerActive // redundancy
	
	if (itembar)
		local bartimer = timerActive/TICRATE
		local fill = ((itembar*barlength)/maxl);
		local length = min(barlength, fill);
		local height = (offset and 1 or 2);
		local bx = (offset and 17 or 11)
		local by = (offset and 27 or 35);

		v.draw(fx+bx, fy+by, dfm_itemtimer[offset+1], V_HUDTRANS|fflags);
		// The left dark "AA" edge
		v.drawFill(fx+bx+1, fy+by+1, ((length == 2) and 2 or 1), height, 12|fflags);
		// The bar itself
		if (length > 2)
			v.drawFill(fx+bx+length, fy+by+1, 1, height, 12|fflags); // the right one
			if (height == 2)
				v.drawFill(fx+bx+2, fy+by+2, length-2, 1, 8|fflags); // the dulled underside
			end
			v.drawFill(fx+bx+2, fy+by+1, length-2, 1, 120|fflags); // the shine
		end
		
		// draw the text over the item
		if (splitscreen < 2)
			v.drawString(fx+tx+1, fy+ty+1, bartimer, V_ALLOWLOWERCASE|fflags) // "drop shadow"
			v.drawString(fx+tx, fy+ty, bartimer, V_ALLOWLOWERCASE|fflags)
		else
			v.drawString(fx+tx+1, fy+ty+1, bartimer, V_ALLOWLOWERCASE|fflags, "thin") // "drop shadow"
			v.drawString(fx+tx, fy+ty, bartimer, V_ALLOWLOWERCASE|fflags, "thin")
		end
	end
end

local function dmod_giveRewardSneaker(p, pity)
	if (leveltime > 230)
	and p.kartstuff[k_itemamount] < 2 
	and (not p.kartstuff[k_roulettetype]) 
	and (not p.kartstuff[k_stolentimer]) then
		p.kartstuff[k_itemblink] = TICRATE/2;
		p.kartstuff[k_itemtype] = KITEM_SNEAKER;
		p.kartstuff[k_itemamount] = ($ + 1);
		if (pity)
			S_StartSound(nil, sfx_itrolm, p);
		else
			S_StartSound(nil, sfx_itrolf, p);
		end
	end
end

local mos = mapobjectscale

local function getDividedPlayerDistanceByPosition(p)
	local pr1 = p
	local pr2 = nil
	for plr in players.iterate
		if (plr.kartstuff[k_position] < p.kartstuff[k_position])
			pr2 = plr
			break;
		end
	end
	if (pr2 == nil) then return 0 end // couldn't find a higher-ranked player, aborting
	local pks1 = pr1.kartstuff
	local pks2 = pr2.kartstuff
	
	local u = nil
	local v = nil
	if ((pr1.mo and pr1.mo.valid) and (pr2.mo and pr2.mo.valid))
		u = pr1.mo
		v = pr2.mo
	end
	
	if ((u == nil) or (v == nil)) then return 0 end // neither player "exists", exiting
	
	local xyDist = R_PointToDist2(u.x,u.y,v.y,v.y)
	local xyzDist = R_PointToDist2(0,u.z,xyDist,v.z)
	
	local mos = mapobjectscale
	local divDist = ((mos < FRACUNIT) and mos or FRACUNIT)
	//if (mos > FRACUNIT) then
	
	return (xyzDist/divDist)
end

local function getPlayerDistanceByPosition(p)
	local pr1 = p
	local pr2 = nil
	for plr in players.iterate
		if (plr.kartstuff[k_position] < p.kartstuff[k_position])
			pr2 = plr
			break;
		end
	end
	if (pr2 == nil) then return 0 end // couldn't find a higher-ranked player, aborting
	local pks1 = pr1.kartstuff
	local pks2 = pr2.kartstuff
	
	local u = nil
	local v = nil
	if ((pr1.mo and pr1.mo.valid) and (pr2.mo and pr2.mo.valid))
		u = pr1.mo
		v = pr2.mo
	end
	
	if ((u == nil) or (v == nil)) then return 0 end // neither player "exists", exiting
	
	local xyDist = R_PointToDist2(u.x,u.y,v.y,v.y)
	local xyzDist = R_PointToDist2(0,u.z,xyDist,v.z)
	
	return xyzDist
end

local function sqr(x)
	return x*x;
end

local function getBonusExponential(a, b)
	local result;
	local aSquare = sqr(a);
	local bDiv = ((b > 0) and (15 - (b - 1)) or 1)
	
	if (aSquare == nil) then return 0 end
	
	result = 200 - ((150 - aSquare * (aSquare/3))/bDiv)
	return result;
end

local function getBonusValue(p)
	local finalBonus = 0;
    local pPos = p.kartstuff[k_position];
	local pcnt = getPlayercount()
    local divto15 = ((pcnt * 100) /15);
    local g = (pPos*10000/divto15);
    local divFactor = (15-((g/100)-2))
    local finalDiv = ((divFactor <= 15) and divFactor or 15)
	
	finalBonus = getBonusExponential(pPos, finalDiv)
	
	if ((pcnt == 1) or (pPos == 1)) then finalBonus = 0 end
    return finalBonus;
end



local function runBonusFactorMetric(p)
	local playerBonus = 0;
	local pPos = p.kartstuff[k_position];
	local mos = mapobjectscale
	local posDist = (getPlayerDistanceByPosition(p)/mos);
	mos = nil
	local bDiv = driftmodData.bonusDiv
	local pBonus = (getBonusValue(p)/bDiv);
	local factorBonus = (((driftmodData.meterRate*(pBonus/4)) + (posDist/270))*2)/100
	local givenBonus = ((factorBonus > driftmodData.meterRate) and factorBonus or (driftmodData.meterRate+(posDist/100)))
	
	if (driftmodData.isOn ~= true) then return end
	
	
	if((pPos > 1) and (pPos <= 3)) // podium bonus factor
		p.meterFactor = (driftmodData.meterRate+(posDist/120))
	elseif (pBonus > 0)
		p.meterFactor = givenBonus
	else
		p.meterFactor = driftmodData.meterRate;
	end
end

local function specialItemFactor(p) // the new son of a bitch system
	if (not dmod_PlayerInWinningSection(p))
		return 2;
	else
		return 1;
	end
	//worst case
	return 0;
end

local function dfMod_MeterDrawing(v, p, x, y, slotx1, slotx2, slotx3, splitscreenMeter)
	if (driftmodData.isOn ~= true) then return end
	local scrwidth = v.width()/v.dupx();
	local widemetric = ((scrwidth >= 400) and 6 or 0);
	local dmSPMeter = driftmodData.specialMtrSize
	
	// color system
	local spColor = SKINCOLOR_SAPPHIRE;
	local rbwSpColor = (1 + (leveltime % (MAXSKINCOLORS-1)));
	local goldColor = v.getColormap(TC_RAINBOW, SKINCOLOR_GOLD);
	local outputColor;
	
	local specialType = p.specialitemtype
	
	if specialType == nil then specialType = 0 end
	
	// set up widescreen adjustment system
	local idx = 1;
	local barwidth = 56;
	
	local barx = 23;
	local bary = 4;
	local barsize = 6;
	
	// get interchanging variables
	local dfLevel = getDriftLevel(p);
	local meterpoints = p.driftPoints;
	local specialpoints = p.specialDriftPoints;
	local snkrCount = p.kartstuff[k_itemamount];
	
	local exPt = ((dfLevel > 1) and (extraPoints[dfLevel]) or 0)
	local exPt2 = ((dfLevel > 0) and (extraPoints[dfLevel]) or 0)
	
	if specialpoints == nil then specialpoints = 0 end // wow epic warning

	local bonusSpPoints = (((specialpoints+(exPt*2)) <= dmSPMeter) and (specialpoints+exPt*2) or dmSPMeter)
	bonusSpPoints = ((specialpoints > 0) and $ or 0) // LOL!!
	
	local vflags = V_HUDTRANS
	
	
	// set bar width for widescreen
	if (scrwidth >= 400)
		barwidth = 78
	end
	
	//4P splitscreen
	if ((splitscreenMeter) and (splitscreenMeter > 0))
		barwidth = 24
		barsize = 4
		bary = 5
	end
	
	local splitdfFactor = 0;
	
	local bonusColor = 229
	if (dfLevel == 2)
		bonusColor = 127
	elseif (dfLevel > 2)
		bonusColor = rbwSpColor;
	end
	
	if (dfLevel > 0)
		if (dmodsparkcolors[dfLevel] ~= "rainbow")
			outputColor = v.getColormap(TC_DEFAULT,  dmodsparkcolors[dfLevel]);
		else
			
			outputColor = v.getColormap(TC_DEFAULT,  rbwSpColor);
		end
		splitdfFactor = 0;
		idx = 2;
	else
		idx = 1;
		splitdfFactor = 2;
		outputColor = v.getColormap(TC_DEFAULT, spColor);
	end
	if meterpoints == nil then meterpoints = 0 end // wow epic warning
	if bonusSpPoints == nil then bonusSpPoints = 0 end
	
	local bonusDfPoints = (((meterpoints+(exPt2)) <= 10000) and (meterpoints+exPt2) or 10000)
	bonusDfPoints = ((meterpoints > 0) and $ or 0)
	if bonusDfPoints == nil then bonusDfPoints = 0 end
	// get total points
    local drawpoints = ((meterpoints*barwidth)/10000);
	local drawspecial = ((specialpoints*(barwidth+2))/dmSPMeter);
	local drawdriftextra = ((bonusDfPoints*barwidth)/10000);
	local drawDfBonus = ((bonusSpPoints*(barwidth+2))/dmSPMeter);
	local drawspecial4p = ((specialpoints*barwidth)/dmSPMeter);
	local drawDfBonus4P = ((bonusSpPoints*barwidth)/dmSPMeter);
	
	
	
	local meterType = driftmodmeter[1+(widemetric/3)]
	if (driftmodData.blueOn == false) then meterType = nobluemeter[1+(widemetric/3)] end
	local meterSpark = driftmodmeter[2]
	
	if (splitscreenMeter == 1)
		meterType = fourPlayerMeter[1+splitdfFactor];
		if (driftmodData.blueOn == false) then meterType = noblue4p[1+splitdfFactor] end
		barx = 15
	elseif (splitscreenMeter == 2)
		meterType = fourPlayerMeter[2+splitdfFactor];
		if (driftmodData.blueOn == false) then meterType = noblue4p[2+splitdfFactor] end
		barx = 16
	end
	
    v.draw(x, y, meterType, vflags, outputColor);
	
	if ((splitscreenMeter) and (splitscreenMeter > 0))
		v.drawFill(x+barx, y+(bary+6), drawDfBonus4P, 1, bonusColor);
		v.drawFill(x+barx, y+(bary+6), drawspecial4p, 1, barColors[2]);
	else
		v.drawFill(x+(barx-1), y+(bary+8), drawDfBonus, 3, bonusColor);
		v.drawFill(x+(barx-1), y+(bary+8), drawspecial, 3, barColors[2]);
		if (idx > 1)
			v.draw(x, y, meterSpark, vflags, outputColor);
		end
	end
	
	if (not splitscreen) // we're using the bog-standard item slots for splitscreen
		v.draw(slotx1, y-35, smallSlot, vflags);
		v.draw(slotx2, y-35, smallSlot, vflags);
		if (driftmodData.blueOn) then v.draw(slotx3, y-35, smallSlot, vflags, goldColor); end // special slot
		
		if (snkrCount == 1) // shitty hack
			v.draw(slotx1, y-35, smallSnkr, vflags);
		elseif (snkrCount > 1)
			v.draw(slotx1, y-35, smallSnkr, vflags);
			v.draw(slotx2, y-35, smallSnkr, vflags);
		end
		
		if (driftmodData.blueOn)
			if (specialType > 0)
				v.draw(slotx3, y-35, specialIcon[specialType], vflags);
				
				local hitNum = ((p.cusDisplay) and p.cusDisplay or 3)
				local hitMeText = "\x82"..customPrompt[hitNum].."\x80"
				v.drawString(slotx2+28, y-33, hitMeText, V_ALLOWLOWERCASE|vflags, "thin")
				hitMeText = nil
				hitNum = nil
			end
			if (p.kartstuff[k_rocketsneakertimer] and ((leveltime %2) == 1))
				v.draw(slotx3, y-35, specialIcon[2], vflags);
			end
		end
		
		local specialTimerType = ((p.kartstuff[k_rocketsneakertimer]) and 2 or 1)
		
		// Extensible meter, currently only used for rocket sneaker...
		local barlength = 26;
		
		local maxl = 1; // WHOOPS
		if (specialType == 1 or p.kartstuff[k_hyudorotimer])
			local hyuumulti = ((kmp_hyudoro and kmp_hyudoro.value) and 6 or 3) //kartmp hyuu extend check
			maxl = ((hyuutime*hyuumulti)/2) - barlength;
		elseif ((specialType == 2) or p.kartstuff[k_rocketsneakertimer])
			maxl = (itemtime*6) - barlength;
		end
		
		local itembar = p.kartstuff[k_rocketsneakertimer]+p.kartstuff[k_hyudorotimer]
		if (itembar)
			local fill = ((itembar*barlength)/maxl);
			local length = min(barlength, fill);
			local height = (2);
			local bx = slotx2 + 31
			local by = y-32;

			v.draw(bx-47, by-1, timerForP1, vflags);
			// The left dark "AA" edge
			v.drawFill(bx+1, by+1, ((length == 2) and 2 or 1), height, 12|vflags);
			// The bar itself
			if (length > 2)
				v.drawFill(bx+length, by+1, 1, height, 12|vflags); // the right one
				if (height == 2)
					v.drawFill(bx+2, by+2, length-2, 1, 8|vflags); // the dulled underside
				end
				v.drawFill(bx+2, by+1, length-2, 1, 120|vflags); // the shine
			end
			local plColor = v.getColormap(TC_RAINBOW, p.skincolor);
			if (plColor == nil)
				plColor = v.getColormap(TC_RAINBOW, SKINCOLOR_SAPPHIRE);
			end
			local bartimer = itembar/TICRATE
			v.draw(slotx2-14, y-44, smallSpecialIcon[specialTimerType], vflags, plColor);
			
			// draw the text over the item
			v.drawString(slotx2+12, y-34, bartimer, V_ALLOWLOWERCASE|vflags, "thin") // "drop shadow"
			v.drawString(slotx2+11, y-35, bartimer, V_ALLOWLOWERCASE|vflags, "thin")
			plColor = nil
		end
	end
	
	v.drawFill(x+barx, y+bary, drawdriftextra, barsize, bonusColor);
    v.drawFill(x+barx, y+bary, drawpoints, barsize, 89);
end

local function drawDfModMeter(v, p)
	if (p.spectator) then return end
    if (driftmodData.isOn ~= true) then return end

    -- get numbers
    local screenYSub = 28
	local bardiff = 55;
	local barwidth = 56;
	local slotsep = 1;
	
	local idx = 1;
    local scrwidth = v.width()/v.dupx();
    local winheight = v.height()/v.dupy();
    local windiff = ((winheight-200)/2)
    local left = (scrwidth - 320)/2;
	
	local scrxdiff = (scrwidth-320);
	local scrydiff = (winheight-200);
	local widemetric = ((scrwidth >= 400) and 6 or 0);
	
	local scrcenterx = ((scrwidth-scrxdiff)/2);
	scrxdiff = nil;
	
	if (scrwidth >= 400)
		bardiff = 56
	end

    local hudx = scrcenterx-bardiff;
	local sl1x = (scrcenterx-51-slotsep)+widemetric;
	local sl2x = (scrcenterx-29+slotsep)+widemetric;
	local sl3x = (scrcenterx-5+slotsep)+widemetric;
	local splitY = (((winheight/2)-windiff));
	local spltHudY = (splitY-screenYSub);
    local hudy = ((winheight-windiff)-screenYSub);
	
	dmod_drawSlots(v, p)
	dmod_drawGoldSlots(v, p)
	if (not splitscreen)
		if (not driftmodData.blueOn)
			sl1x = (scrcenterx-39-slotsep)+widemetric;
			sl2x = (scrcenterx-17+slotsep)+widemetric;
		end
		dfMod_MeterDrawing(v, p, hudx, hudy, sl1x, sl2x, sl3x)
	elseif (splitscreen == 1)
		if p == displayplayers[0]
			dfMod_MeterDrawing(v, p, hudx, spltHudY, sl1x, sl2x, sl3x);
		elseif p == displayplayers[1]
			dfMod_MeterDrawing(v, p, hudx, hudy, sl1x, sl2x, sl3x);
		end
	elseif (splitscreen > 1)
		screenYSub = 16
		hudy = ((winheight-windiff)-screenYSub);
		spltHudY = (splitY-screenYSub);
		if p == displayplayers[0]
			dfMod_MeterDrawing(v, p, 42-left, spltHudY, sl1x, sl2x, sl3x, 1);
		elseif p == displayplayers[1]
			dfMod_MeterDrawing(v, p, (scrwidth-87)-left, spltHudY, sl1x, sl2x, sl3x, 2);
		elseif p == displayplayers[2]
			dfMod_MeterDrawing(v, p, 42-left, hudy-windiff, sl1x, sl2x, sl3x, 1);
		elseif ((p == displayplayers[3]) and (splitscreen == 3))
			dfMod_MeterDrawing(v, p, (scrwidth-87)-left, hudy-windiff, sl1x, sl2x, sl3x, 2);
		end
	end
end

local function runSpecialUsage(p)
	local pks = p.kartstuff
	local botan = ((p.nitroCustomButton) and p.nitroCustomButton or BT_CUSTOM3)
	
	if (p.cmd.buttons & botan)
		p.custom3DownTimer = ($1 + 1)
	else
		p.custom3DownTimer = 0;
	end
	botan = nil
	
	if ((p.custom3DownTimer > 0) and (p.custom3DownTimer < 3) and (p.specialitemtype > 0))
		if (p.specialitemtype == 1)
			pks[k_hyudorotimer] = ((hyuutime*3)/2);
			pks[k_driftboost] = 40; // was rainbow (125) before, setting this to 40 instead (slightly below orange)
			S_StartSound(p.mo, sfx_s3k92);
			S_StartSound(nil, sfx_s3k92, p);
			p.specialitemtype = 0;
		elseif (p.specialitemtype == 2)
			dmod_doRocketSneakerReward(p);
		end
	end
end

local function getKartSpeed(player, doboostpower)
	local k_speed = 150;
	local g_cc = FRACUNIT;
	local xspd = 3072;		-- 4.6875 aka 3/64
	local kartspeed = player.kartspeed;
	local finalspeed;

	if (doboostpower and (not player.kartstuff[k_pogospring]) and (not P_IsObjectOnGround(player.mo)))
		return (75*mapobjectscale); -- air speed cap
	end

	//switch (gamespeed) -- WOW, LUA HAS NO SWITCH STATEMENTS
	if (gamespeed == 0)
		g_cc = 53248 + xspd; //  50cc =  81.25 + 4.69 =  85.94%
	elseif (gamespeed == 2)
		g_cc = 77824 + xspd; // 150cc = 118.75 + 4.69 = 123.44%
	elseif (gamespeed == 1)
		g_cc = 65536 + xspd; // 100cc = 100.00 + 4.69 = 104.69%
	end

	if (G_BattleGametype() and (player.kartstuff[k_bumper] <= 0))
		kartspeed = 1;
	end

	k_speed = ($ + kartspeed*3); // 153 - 177

	local pScale = mapobjectscale
	if (player.mo and player.mo.valid) then pScale = player.mo.scale end
	finalspeed = FixedMul(FixedMul(k_speed<<14, g_cc), pScale)

	if (doboostpower)
		return FixedMul(finalspeed, player.kartstuff[k_boostpower]+player.kartstuff[k_speedboost])
	end
	return finalspeed;
end

local function runHyudoroBoost(p)
	if (JUICEBOX and JUICEBOX.value) then return end // yep
	
	local hyuuboost = ((p.hyuuBoost*(driftmodData.hyuuFactor))/100) // the nerfs increase
	if (hyuuboost == nil) then hyuuboost = (FRACUNIT/6) else hyuuboost = ($/160) end
	
	if (p.kartstuff[k_hyudorotimer])
		p.kartstuff[k_speedboost] = (hyuuboost); // hyuuboost is based on player speed
		p.kartstuff[k_accelboost] = 4*FRACUNIT; // + 400%
	end
end

local function getBoostScale(p)
	local fBst = 0
	if p.kartspeed <= 4 // accel chars only
		local ksp = p.kartspeed
		local boostTime = TICRATE + (TICRATE/3);
		fBst = boostTime/(3+(ksp-1))
	end
	return fBst
end

local function getSneakerPower()
	local case = gamespeed
	local speedboost = 0
	if (case == 0)
		speedboost = max(speedboost, 53740+768);
	elseif (case == 2)
		speedboost = max(speedboost, 17294+768);
	else
		speedboost = max(speedboost, 32768);
	end
	
	return speedboost;
end

local sneakertime = TICRATE + (TICRATE/3); 

local function usingSneaker(p)
	local result = false;
	local usedType = 0;
	local used = false
	if (p.kartstuff[k_itemamount] >= p.krdItemAmt)
		p.krdItemAmt = p.kartstuff[k_itemamount];
		p.krdItemBuffer = p.kartstuff[k_itemtype];
	else
		used = true
		if (p.krdItemBuffer) usedType = p.krdItemBuffer end
		p.krdItemAmt = p.kartstuff[k_itemamount];
	end
	local atkIsDown = ((p.cmd.buttons & BT_ATTACK));
	if (atkIsDown) 
		if ((not p.attackDownTimer) or (p.attackDownTimer == 0)) then p.attackDownTimer = 1 else p.attackDownTimer = ($1+1) end
	else
		p.attackDownTimer = 0
	end
	
	local noHyuu = ((p.kartstuff[k_stolentimer] == 0) and (p.kartstuff[k_stealingtimer] == 0));
	local holdingItem = (p.kartstuff[k_itemheld] or p.kartstuff[k_eggmanheld]);
	local onGround = P_IsObjectOnGround(p.mo)
	if ((used and ((usedType == KITEM_SNEAKER) or (usedType == KITEM_ROCKETSNEAKER))) or ((p.kartstuff[k_rocketsneakertimer] > 1) and ((p.attackDownTimer) and p.attackDownTimer == 1)))
		if (atkIsDown and (not holdingItem) and onGround and noHyuu)
			result = true
		end
	end
	
	return result;
end

addHook("MobjThinker", function(mo) // blue flames to signify blue meter bonus
	if (driftmodData.isOn ~= true) then return end; // not necessary if nitro ain't there
	if (driftmodData.blueOn == false) then return end // unneccesary if the blue meter's off
	local targ = mo.target
	
	if (targ)
		if mo.target.player
			local p = mo.target.player
			if (p.blueBoostVisual <= 1)
				mo.colorized = true
				mo.color = SKINCOLOR_SAPPHIRE
			else
				mo.colorized = false
			end
		elseif (targ.type == MT_ROCKETSNEAKER)
			local rocketTarg = targ.target
			
			if (rocketTarg and rocketTarg.player)
				local p = rocketTarg.player
				if (p.blueBoostVisual <= 1)
					mo.colorized = true
					mo.color = SKINCOLOR_SAPPHIRE
				else
					mo.colorized = false
				end
			end
		end
	end
end, MT_BOOSTFLAME)

//sneaker trail stuff moved to its own lua

local function runDriftMod(p)
    if (p.dmodSetup ~= true)
		p.hyuuBoost = 0
		p.realKSpeed = 0;
		p.krdItemAmt = 0;
        p.driftPoints = 0;
		p.doRespawnPity = 0;
		p.spinoutPity = false;
		p.blueBoost = false;
		p.blueBoostVisual = 0;
		p.specialDriftPoints = 0;
		p.specialitemtype = 0;
		p.specialBlink = 0;
		p.lastDriftLevel = 0;
		p.meterFactor = driftmodData.meterRate;
        p.dmodSetup = true;
    elseif (leveltime <= 230)
		p.specialDriftPoints = 0;
		p.doRespawnPity = 0;
		p.spinoutPity = false;
		p.blueBoostVisual = 0;
		p.blueBoost = false;
		p.bluePanel = false;
		p.specialitemtype = 0;
		p.custom3DownTimer = 0;
		p.krdItemAmt = 0;
		p.driftPoints = 0;
		p.realKSpeed = getKartSpeed(p);
		local pks = p.realKSpeed
		p.hyuuBoost = pks-((pks*1243)/1000)
		pks = nil
	end
	
	if (p.mo and p.mo.valid)
		if (p.kartstuff[k_rocketsneakertimer] and (driftmodData.limitRockets == true))
			dmod_rocketLimiter(p)
		end
		if (p.specialBlink > 0) then p.specialBlink = ($1 - 1) end
		
		if (p.playerstate ~= PST_DEAD)
			if (driftmodData.blueOn == false)
				p.specialDriftPoints = 0
			end
			if (not P_PlayerTouchingSectorSpecial(p,4,6))
				p.bluePanel = false;
			end
			local drip = usingSneaker(p)
				if (drip == true)
					p.blueBoostVisual = ($1 + 1);
				end
			drip = nil
			
			if (p.kartstuff[k_sneakertimer])
				p.boostlog = p.kartstuff[k_sneakertimer]
				if (p.didBoostScale ~= true)
					p.kartstuff[k_sneakertimer] = ($ + getBoostScale(p))
					p.didBoostScale = true
				end
				
				if (p.blueBoost ~= true)
					
					if (p.specialitemtype < 1) p.specialDriftPoints = ($1 + 7500); end
					p.blueBoost = true
					
				end
				local playerBoost = p.kartstuff[k_speedboost]
				local sneakertime = getSneakerPower(); 
				if ((P_PlayerTouchingSectorSpecial(p,4,6)) and (p.bluePanel ~= true))
					p.blueBoostVisual = ($1 + 1);
					p.bluePanel = true
				end
			else
				p.boostlog = nil
				p.blueBoost = false
				p.blueBoostVisual = 0;
				p.didBoostScale = false
			end
			if (p.kartstuff[k_respawn])
				p.doRespawnPity = 1;
			else
				if (P_IsObjectOnGround(p.mo) and (p.doRespawnPity))
					if (p.specialitemtype < 1) p.specialDriftPoints = ($1 + 12000); end
					dmod_giveRewardSneaker(p, true)
					p.doRespawnPity = 0;
				end
			end
			if (p.kartstuff[k_spinouttimer])
				if ((p.spinoutPity ~= true) and (driftmodData.blueOn == true))
					if (p.specialitemtype < 1) p.specialDriftPoints = ($1 + 7000) end;
					p.spinoutPity = true
				end
			else
				p.spinoutPity = false
			end
			if (p.kartstuff[k_drift])
				local dLevel = getDriftLevel(p);
				local dRate = K_GetKartDriftSparkValue(p);
				if (p.kartstuff[k_driftcharge] > (dRate/3))
					p.lastDriftLevel = dLevel;
					if ((P_IsObjectOnGround(p.mo)) or (p.kartstuff[k_pogospring]))
						p.driftPoints = ($1 + (p.meterFactor))
						if (((p.specialitemtype < 1) and (p.kartstuff[k_position] > 1) and (driftmodData.blueOn == true)) or (dmodDebug == true)) then p.specialDriftPoints = ($1 + ((driftmodData.blueRate)/3)) end
					end
				end
			elseif (p.kartstuff[k_aizdriftstrat] and (not p.kartstuff[k_drift])) // sliptide bonus
				if ((P_IsObjectOnGround(p.mo)) or (p.kartstuff[k_pogospring]))
					p.driftPoints = ($1 + ((p.meterFactor*2)/3))
				end
			elseif (p.lastDriftLevel > 0)
				local bDiv = driftmodData.bonusDiv
				local pb = (getBonusValue(p)/bDiv);
				p.driftPoints = ($1 + ((p.lastDriftLevel)*200))
				if (((p.specialitemtype < 1) and (K_IsPlayerLosing(p)) and (driftmodData.blueOn == true)) or (dmodDebug == true)) then p.specialDriftPoints = ($1 + ((p.lastDriftLevel)*200)) end
				p.kartstuff[k_driftboost] = $1 + (pb/4)
				p.lastDriftLevel = 0;
				pb = nil
				bDiv = nil
			end
			
			if (leveltime > 230)
				local mos = mapobjectscale
				local pPos = p.kartstuff[k_position]
				local pDist = (getDividedPlayerDistanceByPosition(p))
				local blueFactor = ((driftmodData.blueRate/3)+(pPos*13))
				runHyudoroBoost(p)
				
				if (((p.specialitemtype < 1) and (driftmodData.blueOn == true)) or (dmodDebug == true)) then 
					if (not p.exiting)
						if (p.kartstuff[k_position] > 1)
							p.specialDriftPoints = ($1 + blueFactor)
						elseif (p.kartstuff[k_position] == 1)
							p.specialDriftPoints = ($1 + (driftmodData.blueRate/6))
						end
					end
				end
				blueFactor = nil
				mos = nil
				runBonusFactorMetric(p);
				runSpecialUsage(p);
				if ((p.dfmNotice == nil))
					chatprintf(p, infoSt1);
					chatprintf(p, infoSt2);
					p.dfmNotice = true;
				end
			end
		end
		
		if (p.driftPoints >= 10000)
			dmod_giveRewardSneaker(p)
			p.driftPoints = 0;
		end
		
		if (p.specialDriftPoints >= driftmodData.specialMtrSize)
			if (p.specialitemtype < 1)
				if (not (dmodDebug == true))
					p.specialitemtype = specialItemFactor(p);
				else
					p.specialitemtype = 2
				end
				p.specialBlink = TICRATE/2;
				S_StartSound(nil, sfx_itrolk, p);
			end
			p.specialDriftPoints = 0;
		end
	end
end

local function playerThinkData(p) // this keeps up and I fucking port the playerthink hook
	if ((driftmodData.isOn == true)) // we have our own item slot system
        if (not xItemLib)
			hud.disable("item");
		else
			p.xItemData.enableHud = false;
		end
    else
		if (not xItemLib)
			hud.enable("item");
		else
			p.xItemData.enableHud = true;
		end
	end
	
	if (driftmodData.isOn ~= true) then return end
	runDriftMod(p);
end


// originally I used a binary search+ merge sort algorithm to find and remove item boxes
// was cool, but the game didn't agree one bit with what I was doing, so it's gone now
// instead there's this mobjthinker hell below

addHook("ThinkFrame", do
	for p in players.iterate
		playerThinkData(p)
	end
	
	if (driftmodData.isOn ~= true) then return end
end)

addHook("MobjThinker", function(mo)
	if (driftmodData.isOn ~= true) then return end;
	
	if ((leveltime <= 230) and (leveltime > 4))
		P_RemoveMobj(mo);
	end
end, MT_RANDOMITEM)

addHook("MobjThinker", function(mo)
	if (driftmodData.isOn ~= true) then return end;
	
	if ((leveltime <= 230) and (leveltime > 4))
		P_RemoveMobj(mo);
	end
end, MT_CDUFO)

addHook("MobjThinker", function(mo)
	if (driftmodData.isOn ~= true) then return end;
	
	if ((leveltime <= 230) and (leveltime > 4))
		P_RemoveMobj(mo);
	end
end, MT_RANDOMITEMBOXSPAWNER)

addHook("MobjThinker", function(mo)
	if (driftmodData.isOn ~= true) then return end;
	
	if ((leveltime <= 230) and (leveltime > 4))
		P_RemoveMobj(mo);
	end
end, MT_RANDOMITEMBOX)

local function mapMyBloodyCustom()
	for p in players.iterate
		if (not ((p.specialBtMem) or (p.cusPref))) then continue end // no reason to set ANYTHING if you've got jackshit
		
		if ((not p.nitroCustomButton) or (p.nitroCustomButton ~= p.specialBtMem))
			local pref = p.cusPref;
			CONS_Printf(p, "Your special item button is now Custom "..pref)
			p.nitroCustomButton = p.specialBtMem
			p.cusDisplay = p.cusPref; // for HUD text
			// making this attached to the player
			p.myInfoSt2 = "Your ".."\x84".."blue meter ".."\x80".."will fill over time. \n Once full, hit ".."\x82".."Custom "..pref.."\x80".." to use a ".."\x82".."special item!".."\x80".."\n(This message will only appear once.)";
			pref = nil
		end
		
	end
end

addHook("MapLoad", do
	driftmodData.isOn = false
	if (cv_driftmod.value == 1)
		driftmodData.isOn = true;
	end
	if (driftmodData.isOn == true)
		mapMyBloodyCustom()
	end
end)

--neo-scoreboard shit

addHook("ThinkFrame", function()
	if dm_neoscoreboard then return end
	if server and (CV_FindVar("hm_scoreboard")) and leveltime > TICRATE 
		HM_Scoreboard_AddMod({disp = "KartRider Nitro", var = "driftmod"})
		HM_Scoreboard_AddTip({msg = "Sliptiding will increase your orange meter by 1/3rds the standard rate. Use this to your advantage!"})
		HM_Scoreboard_AddTip({msg = "Spinning out and falling off will fill your blue meter a good bit. This'll give struggling players a better chance at special items."})
		HM_Scoreboard_AddTip({msg = "Falling off grants you a Sneaker as a pity item. Use this to get right back into the action!"})
		dm_neoscoreboard = true
	end
end)


hud.add(drawDfModMeter, game)